extern int      Rekno.Size.Pips                 =  10;
//+------------------------------------------------------------------+
//| Renko Bars                                                       |
//+------------------------------------------------------------------+
int bars.renko,     indicator.counted,      bars.counted;   void OnInitRB(){
    bars.renko = 0; indicator.counted = 0;  bars.counted=0; }
double  high.renko[],   low.renko[],    close.renko[];  datetime time.renko[];
double  adx.fract[],    pDMI.fract[],   nDMI.fract[],   ma.value[];
void    OnTickRenko(){
    for(int iBar = Bars - 1 - bars.counted; iBar >= 0; iBar--){ // Handle
        double  Hi  =  High[iBar],  Cl  = Close[iBar],          // disconnection
                Lo  =   Low[iBar],  Op  =  Open[iBar];          // and initial
        datetime T  = Time[iBar];   static datetime TimeLast;   // creation.
        if (TimeLast != T){ TimeLast = T;                   // Process a new bar
            static double lastHi;   lastHi = Op;
            static double lastLo;   lastLo = Op;
            RenkoUpdate(Op, T);   T++;                // Handle gaps here.
        }
        else if (iBar == 0) T = TimeCurrent();              // Same bar new tick
        else                T = time.renko[0]+1;            // Missed some ticks
        // On new UP bar, go down to low first, then high, then close.
        if (lastLo > Lo && Cl > Op){        RenkoUpdate(Lo, T); lastLo = Lo; }
        if (lastHi < Hi){                   RenkoUpdate(Hi, T); lastHi = Hi; }
        if (lastLo > Lo){                   RenkoUpdate(Lo, T); lastLo = Lo; }
        if (lastLo != Cl && lastHi != Cl)   RenkoUpdate(Cl, T);
    }   // iBar
    lastHi = High[0];   lastLo = Low[0];    bars.counted = Bars - 1;
    CallAgain(high.renko[0]-Point,"rH");                        // At or above,
    CallAgain( low.renko[0]+Point,"rL");                        // the limit.
    DisplayIndicators();
}   // OnTickRenko
void    RenkoUpdate(double P, datetime& T){
    double  renkoSize   = Rekno.Size.Pips * pips2dbl;
    if (bars.renko > 0){
        while(P + Point_2 > high.renko[0]){                 // at or above
              low.renko[0] =  high.renko[0] - renkoSize;    //   Low = open
            close.renko[0] =  high.renko[0];                // close = high
            ResizeBuffers();
             time.renko[0] = T; T++;
             high.renko[0] =  high.renko[1] + renkoSize;    // New bar
              low.renko[0] =   low.renko[1] - renkoSize;    // limits.
            UpdateIndicators();
        }
        while(P - Point_2 < low.renko[0]){                  // at or below
             high.renko[0] =   low.renko[0] + renkoSize;    //  high = open
            close.renko[0] =   low.renko[0];                // close =  low
            ResizeBuffers();
             time.renko[0] = T; T++;
             high.renko[0] =  high.renko[1] + renkoSize;
              low.renko[0] =   low.renko[1] - renkoSize;
            UpdateIndicators();
    }   }
    else{
        ResizeBuffers();
         time.renko[0] = T; T++;            // Rounding for debugging purpose
         high.renko[0] = MathRound((P + renkoSize/2.)/pips2dbl)*pips2dbl;
          low.renko[0] = high.renko[0] - renkoSize;
    }
}
void    ResizeBuffers(){
    if (bars.renko > 1000){                                 // Drop old bars.
        bars.renko          -= 900;
        ArrayResize( high.renko,bars.renko); ArrayResize( adx.fract,bars.renko);
        ArrayResize(  low.renko,bars.renko); ArrayResize(pDMI.fract,bars.renko);
        ArrayResize(close.renko,bars.renko); ArrayResize(nDMI.fract,bars.renko);
        ArrayResize( time.renko,bars.renko); ArrayResize(  ma.value,bars.renko);
    }
    bars.renko++;                                           // Shift bars left.
    ResizeBuffer(  high.renko,bars.renko); ResizeBuffer( adx.fract, bars.renko);
    ResizeBuffer(   low.renko,bars.renko); ResizeBuffer(pDMI.fract, bars.renko);
    ResizeBuffer( close.renko,bars.renko); ResizeBuffer(nDMI.fract, bars.renko);
    ResizeBufferDt(time.renko,bars.renko); ResizeBuffer(  ma.value, bars.renko);
}
int     iRenkoShift(int iBar){          // Last nonzero Renko covering chart bar
    if (iBar==0) datetime   when = TimeCurrent();
    else                    when = Time[iBar-1];
    for(int iRnk=0; iRnk < bars.renko; iRnk++) if(
        time.renko[iRnk] <= when)   break;
    return( MathMinI(bars.renko-1, iRnk+1) );
}
double  tsl.std.value,                                      // \ Export to
        atr.value;                                          // / SetStops
void    UpdateIndicators(){
    #define DRAWBEGIN 3 // Look back c.r[2] for TR/ATR/ADX
    if (bars.renko < DRAWBEGIN) return;
    if (bars.renko > TSL.MA.Length){
    ma.value[1]  =     iMAOnArray(close.renko,0,TSL.MA.Length,0, TSL.MA.Mode,1);
    tsl.std.value= iStdDevOnArray(close.renko,0,TSL.MA.Length,TSL.MA.Mode, 0,1);
    }
    double  TR          = MathMax(high.renko[1], close.renko[2])    // True
                        - MathMin( low.renko[1], close.renko[2]),   // range
            atrAlpha    = 2.0 / (1+ATR.Length),
            adxAlpha    = 2.0 / (1+ADX.Length);
            if (bars.renko == DRAWBEGIN){   atrAlpha = 1.;  adxAlpha = 1.;  }
    // I use EMA for simplicity, mql4 ATR uses SMA.
    atr.value += atrAlpha*(TR - atr.value);
    pDMI.fract[1] = pDMI.fract[2];  adx.fract[1] =  adx.fract[2];
    nDMI.fract[1] = nDMI.fract[2];
    if (TR > 0.) {                              double  // Directional movement.
        pdm = MathMax(0, high.renko[1] - high.renko[2]),
        ndm = MathMax(0,  low.renko[2] -  low.renko[1]);
        if      (pdm<ndm) pdm=0;                // Only the largest
        else if (ndm<pdm) ndm=0;                // Movement is counted.
        // The ADX/DMI use a 0-100 range. I use 0-1.00 for efficiency
        pDMI.fract[1] += adxAlpha * (pdm/TR - pDMI.fract[1]);
        nDMI.fract[1] += adxAlpha * (ndm/TR - nDMI.fract[1]);           double
            div     = pDMI.fract[1] + nDMI.fract[1];
        if (div != 0.){                                                 double
            DMId    = pDMI.fract[1] - nDMI.fract[1],
            DXd     = MathAbs(DMId) / div;
            adx.fract[1] += adxAlpha*(DXd - adx.fract[1]);
        }
    }
}   // UpdateIndicators
